#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
from zope.interface import implements
import zope.location
from zope.app.component import hooks
from z3c.pagelet.browser import BrowserPagelet

from cando.newskin import interfaces, traverser, CourseChooser, SectionChooser
from cando.virginia.browser import virginia
from cando.virginia.interfaces import ICompetencies


class Go(BrowserPagelet):
    implements(interfaces.ICompetencyView)

    def update(self):
        self.no_crumb_options = True

class CourseCompetenciesGo(BrowserPagelet, CourseChooser):
    implements(interfaces.ICompetencyView)

    courseLink = '/view_competencies.html'

class SectionCompetenciesGo(BrowserPagelet, SectionChooser):
    implements(interfaces.ICompetencyView)

    sectionLink = '/view_competencies.html'

# -----[ Competencies Option ]-----------------------------------------------

CompetenciesOption = traverser.OptionFactory(u'Competencies')

CompetenciesOptionTraverserPlugin = traverser.OptionTraverserFactory(
    'competencies', CompetenciesOption)

# -----[ Global Competency Option ]------------------------------------------

def GlobalCompetenciesOption(traverser, context):
    app = hooks.getSite()
    return zope.location.LocationProxy(
        ICompetencies(app), context, traverser.traversalName)

GlobalCompetenciesOptionTraverserPlugin = traverser.OptionTraverserFactory(
    'global', GlobalCompetenciesOption, False)


# -----[ Course Competency Option ]------------------------------------------

def CourseCompetenciesOption(traverser, context):
    app = hooks.getSite()
    return zope.location.LocationProxy(
        app['courses'], context, traverser.traversalName)

CourseCompetenciesOptionTraverserPlugin = traverser.OptionTraverserFactory(
    'course', CourseCompetenciesOption, False)

# -----[ Reused Views ]------------------------------------------------------

class CompetenciesClassicView(BrowserPagelet,
                              virginia.CompetenciesClassicView):
    implements(interfaces.ICompetencyView)
