#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
"""Skill Driver Interfaces

$Id$
"""
__docformat__ = 'restructuredtest'

import zope.schema
from zope.app.container import interfaces
from zope.app.container import constraints
from zope.interface import Interface

from zope.i18nmessageid import MessageFactory
_ = MessageFactory('cando')

class ISkillDriver(Interface):
    """A type of assignment that requires the mastering of a set of
    competencies."""

    title = zope.schema.TextLine(
        title= _(u"Title"),
        description= _(u"The title of the assignment"),
        required=True)

    description = zope.schema.Text(
        title= _(u"Description"),
        description= _(u"A general description of the activity using the skills"),
        required=False)

#    constraints.containers('cando.skilldriver.interfaces.ISkillDrivers',
#                           'cando.skilldriver.interfaces.ISectionSkillDrivers')


class ISkillDrivers(interfaces.IContainer):
    """A container of SkillDriver objects"""

    constraints.contains(ISkillDriver)

class ISectionSkillDrivers(interfaces.IContainer):
    """A container of SkillDriver obejcts for a section.

    This container will store it's own skill drivers as well as deliver the
    course's skill drivers via proxy.
    """

    constraints.contains(ISkillDriver)

