##############################################################################
# copyright.py - adds a copyright header to all python files in a directory  #
# tree.                                                                      #
##############################################################################

import os

def walkthrough(header, directory, names):
    """Run through the directory tree, edit the appropriate files."""
    for name in names:
        if name[-3:] == '.py' and 'copyright.py' not in name:  
            name = os.path.join(directory, name)
            text = header + file(name).read()
            # The file's reopened here so that text overwrites its old contents
            # instead of just appending to it (Having just read() from it)
            file(name, 'w').write(text)
            print name

# The header to be used -- change this to change the header.
copyright_header = """#
# CanDo - Web based competency tracking system.
# Copyright (C) 2006 Arlington Public Schools, Arlington, VA and The
# Shuttleworth Foundation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
"""

os.path.walk(".", walkthrough, copyright_header)
